// $Id: RenderSettings.cc,v 1.6 2002/12/28 01:30:53 mthuurne Exp $

#include "RenderSettings.hh"


RenderSettings::RenderSettings()
{
	scanlineAlpha = new IntegerSetting(
		"scanline", "amount of scanline effect: 0 = none, 100 = full",
		20, 0, 100);
	
	horizontalBlur = new IntegerSetting(
		"blur", "amount of horizontal blur effect: 0 = none, 100 = full",
		50, 0, 100);
	
	deinterlace = new BooleanSetting(
		"deinterlace", "deinterlacing on/off", true);
	
	std::map<const std::string, Accuracy> accMap;
	accMap["screen"] = ACC_SCREEN;
	accMap["line"]   = ACC_LINE;
	accMap["pixel"]  = ACC_PIXEL;
	accuracy = new EnumSetting<Accuracy>(
		"accuracy", "rendering accuracy", ACC_LINE, accMap);

}

RenderSettings::~RenderSettings()
{
	delete scanlineAlpha;
	delete horizontalBlur;
	delete deinterlace;
	delete accuracy;
}
