// $Id: IDEDeviceFactory.cc,v 1.1 2002/12/18 19:47:21 m9710797 Exp $

#include "IDEDeviceFactory.hh"
#include "MSXConfig.hh"
#include "IDEHD.hh"


IDEDevice* IDEDeviceFactory::create(const std::string &name,
                                    const EmuTime &time)
{
	MSXConfig::Config *config = MSXConfig::Backend::instance()->
		getConfigById(name);
	const std::string type = config->getType();

	if (type == "IDEHD") {
		return new IDEHD(config, time);
	}
	PRT_ERROR("Unknown IDE device: " << type);
	return NULL;
}
