// $Id: MSXFmPac.hh,v 1.11 2002/12/08 15:48:45 m9710797 Exp $

#ifndef __MSXFMPAC_HH__
#define __MSXFMPAC_HH__

#include "MSXYM2413.hh"
#include "CommandLineParser.hh"
#include "SRAM.hh"


class MSXFmPacCLI : public CLIOption, public CLIPostConfig
{
	public:
		MSXFmPacCLI();
		virtual void parseOption(const std::string &option,
		                         std::list<std::string> &cmdLine);
		virtual const std::string& optionHelp();
		virtual void execute(MSXConfig::Backend *config);
};


class MSXFmPac : public MSXYM2413
{
	public:
		MSXFmPac(MSXConfig::Device *config, const EmuTime &time);
		virtual ~MSXFmPac(); 
		
		virtual void reset(const EmuTime &time);
		virtual byte readMem(word address, const EmuTime &time);
		virtual void writeMem(word address, byte value, const EmuTime &time);

	private:
		void checkSramEnable();
		
		static const char* PAC_Header;
		bool sramEnabled;
		byte bank;
		byte r5ffe, r5fff;
		SRAM sram;
};

#endif
